package com.dts.project.dao;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.dts.core.dao.AbstractDataAccessObject;
import com.dts.core.util.CoreHash;
import com.dts.core.util.DateWrapper;
import com.dts.core.util.LoggerManager;
import com.dts.project.model.CustPhoneAdrsNumberHistoryModel;
import com.dts.project.model.PhoneModel;

public class CustPhoneAdrsNumberHistoryDAO extends AbstractDataAccessObject {
	public boolean flag=false;
	public Connection con=null;
	
	public CustPhoneAdrsNumberHistoryModel getCustAddressDetails(int custid){
		
		CoreHash aCoreHash=new CoreHash();
		aCoreHash.clear();
		System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
		
		int sno=1;	
		ResultSet rs=null;
		//PhoneModel um=null;
		CustPhoneAdrsNumberHistoryModel  um=null;
		Statement st=null;
	        try
	        {
	        	con=getConnection();     	
	        	st=con.createStatement();
	       	String sql="SELECT HA.PHNO,HA.CUSTID,CM.CFSTNAME,HA.NEWADDRES, TO_CHAR(HA.APPLYDATE,'DD-MM-YY'), TO_CHAR(HA.CHANGEDDATE,'DD-MM-YY'), HA.STATUS, HA.INCHRGID, EM.EMPFSTNAME, HA.TXID   FROM  HSTRY4CHNGADDRS  HA, CUSTOMER CM, EMPLOYEESMASTER  EM  WHERE(HA.CUSTID=CM.CUSTID) AND(HA.INCHRGID=EM.EMPID) AND (HA.CUSTID="+custid+" AND HA.TXID =(SELECT MAX(TXID) FROM HSTRY4CHNGADDRS WHERE CUSTID="+custid+" AND STATUS LIKE 'ACTIVE'))";
				
				rs=st.executeQuery(sql);
				while(rs.next()){				
				um=new CustPhoneAdrsNumberHistoryModel();			
				String cid=rs.getString(1);			
				um.setCustnewphno(cid);			
				um.setCustid(rs.getInt(2));			
				um.setCustname(rs.getString(3));
				um.setNewaddress(rs.getString(4));				
				um.setAplydate(rs.getString(5));
				um.setIsuedate(rs.getString(6));
				um.setStatus(rs.getString(7));
				um.setInchrgid(rs.getInt(8));
				um.setInchrgname(rs.getString(9));
				um.setTxid(rs.getInt(10));
								
				 aCoreHash.put(new Integer(sno),um);
				    sno++;
			  
	             }
		}
		catch(Exception e)
		{e.printStackTrace();
			LoggerManager.writeLogWarning(e);
		}
		finally
		{
		 try{
			 if(con!=null)
				 con.close();
			 
		 }
		 catch(Exception e){}
		}
		return um;
	}

	
	
public CustPhoneAdrsNumberHistoryModel getPertCustBillDetails(int custid){
		
		CoreHash aCoreHash=new CoreHash();
		aCoreHash.clear();
		System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
		
		int sno=1;	
		ResultSet rs=null;		
		CustPhoneAdrsNumberHistoryModel  um=null;
		Statement st=null;
	        try
	        {
	        	con=getConnection();     	
	        	st=con.createStatement();
	       	String sql="SELECT   PBM.PHNO, PBM.CUSTID, CM.CFSTNAME,PBM.BILLID, PBM.CONECTYPEID, CTM.CONTYPENAME,  PBM.TLKTIME, PBM.PAYAMT, TO_CHAR(PBM.BILISUDATE,'DD-MM-YY'), PBM.OTHERTAXES, PBM.TOTALBILLCOST, PBM.STATUS, PBM.TXID   FROM  PHONEBILLINGMSTR   PBM, CUSTOMER   CM,  CONECTIONTYPEMSTR  CTM WHERE(PBM.CUSTID=CM.CUSTID) AND(PBM.CONECTYPEID=CTM.CONTYPEID) AND STATUS LIKE 'NOTPAID' AND PBM.CUSTID="+custid;
				
				rs=st.executeQuery(sql);
				while(rs.next()){				
				um=new CustPhoneAdrsNumberHistoryModel();			
				String cid=rs.getString(1);			
				um.setCustnewphno(cid);			
				um.setCustid(rs.getInt(2));			
				um.setCustname(rs.getString(3));
				um.setBillid(rs.getInt(4));				
				um.setNewconectypeid(rs.getInt(5));
				um.setNewconectypename(rs.getString(6));
				um.setTalktime(rs.getString(7));
				um.setPayamt(rs.getDouble(8));
				um.setIsuedate(rs.getString(9));
				um.setOthertax(rs.getDouble(10));
				um.setTotalamt(rs.getDouble(11));
				um.setStatus(rs.getString(12));				
				um.setTxid(rs.getInt(13));
								
				 aCoreHash.put(new Integer(sno),um);
				    sno++;
			  
	             }
		}
		catch(Exception e)
		{e.printStackTrace();
			LoggerManager.writeLogWarning(e);
		}
		finally
		{
		 try{
			 if(con!=null)
				 con.close();
			 
		 }
		 catch(Exception e){}
		}
		return um;
	}

	
	
public boolean CustAddressRequestForChangeDetails(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call CUST_ADRS_CHANGE_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());
   cstmt.setString(3, amodel.getOldaddress());
   cstmt.setString(4, amodel.getNewaddress());
   cstmt.setString(5, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}

	

public boolean adminAceptCustAdrsRequest(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call ADMNACPT_CUSTADRS_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());   
   cstmt.setString(3, amodel.getNewaddress());
   cstmt.setInt(5, amodel.getInchrgid());
   cstmt.setString(4, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}

	

public boolean adminAceptCustFacilRequest(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call ADMNACPT_CUSTFACIL_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());   
   cstmt.setInt(3, amodel.getFaciltypeid());
   cstmt.setInt(5, amodel.getInchrgid());
   cstmt.setString(4, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}




public boolean adminAceptCustPurposeTypeRequest(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call ADMNACPT_CUSTPRPOSETYPE_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());   
   cstmt.setInt(3, amodel.getPerposetypeid());
   cstmt.setInt(5, amodel.getInchrgid());
   cstmt.setString(4, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}

public boolean adminAceptCustConnectTypeRequest(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call ADMNACPT_CUSTCONNETCTYPE_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());   
   cstmt.setInt(3, amodel.getConectypeid());
   cstmt.setInt(5, amodel.getInchrgid());
   cstmt.setString(4, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;	
	}



public boolean adminChangeAllFacilTypeCustomerPhoneNumber(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		        	
      	con=getConnection();		       
	  cstmt=con.prepareCall("{ call ADMN_CHNG_ALLCUST_PHNO(?,?,?)}"); 	      
      cstmt.setString(1, amodel.getPrefix());  
      System.out.println("----1-------"+amodel.getPrefix());
      cstmt.setInt(2, amodel.getInchrgid());
      System.out.println("---2-------"+amodel.getInchrgid());
      cstmt.setInt(3, amodel.getFaciltypeid());      
  System.out.println("-------3----------"+amodel.getFaciltypeid());
	       int i= cstmt.executeUpdate();
	       System.out.println("-----i----------"+i);
	       
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}




public boolean CustRequestForChangeFaciltypeDetails(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call CUST_FACILTYPE_CHANGE_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());
   cstmt.setInt(3, amodel.getFaciltypeid());
   cstmt.setInt(4, amodel.getNewfaciltypeid());
   cstmt.setString(5, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}
	

public boolean CustRequestForChangePerposeTypeDetails(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call CUST_PERPOSETYPE_CHANGE_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());
   cstmt.setInt(3, amodel.getPerposetypeid());
   cstmt.setInt(4, amodel.getNewperposetypeid());
   cstmt.setString(5, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}
	
public boolean CustRequestForChangeConectionTypeDetails(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call CUST_CONECTIONTYPE_CHANGE_REQ(?,?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());        
   cstmt.setString(2, amodel.getCustnewphno());
   cstmt.setInt(3, amodel.getConectypeid());
   cstmt.setInt(4, amodel.getNewconectypeid());
   cstmt.setString(5, DateWrapper.parseDate(amodel.getAplydate()));      
   
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}
	
	

public boolean adminGenerateCustomerPhoneBill(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call GEN_CUST_BILL_BY_ADMIN(?,?,?,?)}");
   
	        
	 cstmt.setInt(1, amodel.getCustid());   
	 System.out.println("------amodel.getCustid()-------"+amodel.getCustid());
   cstmt.setString(2, amodel.getCustnewphno());
   System.out.println("---amodel.getCustnewphno()-----"+amodel.getCustnewphno());
   cstmt.setString(3, amodel.getTalktime()); 
   System.out.println("----amodel.getTalktime()----"+amodel.getTalktime());
   cstmt.setDouble(4, amodel.getOthertax());
   System.out.println("----amodel.getOthertax()-------"+amodel.getOthertax());
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}
	
public boolean CustomerPayingPhoneBills(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call CUST_PAYING_PHONE_BILLS(?,?,?,?,?,?)}");
   
	        
	  cstmt.setInt(1, amodel.getCustid());        
      cstmt.setString(2, amodel.getCustnewphno());
      cstmt.setInt(3, amodel.getNewconectypeid());
      cstmt.setInt(4, amodel.getBillid());
      cstmt.setInt(5, amodel.getTxid());
      cstmt.setDouble(6, amodel.getTotalamt());
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}

	
public boolean CustAddComplaintToAdmin(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call ADD_CUST_CMPLTS(?,?,?,?)}");
   
	         cstmt.setString(1, amodel.getQuerytype());
	         cstmt.setInt(2, amodel.getCustid());        
             cstmt.setString(3, amodel.getCustnewphno());  
             cstmt.setString(4, amodel.getQuerydesc()); 
             //cstmt.setInt(5, amodel.getInchrgid());
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}


public boolean ResposeToCustGeneralComplaint(CustPhoneAdrsNumberHistoryModel  amodel){
	CallableStatement cstmt=null;
	  try 
	    {
		  
      	
      	con=getConnection();		       
	        cstmt=con.prepareCall("{ call ADMIN_UPDATE_CUST_CMPLTS(?,?,?,?,?)}");
   
	        
	         cstmt.setInt(1, amodel.getCustid());  
	         cstmt.setInt(2, amodel.getQueryid());	         
             cstmt.setString(3, amodel.getCustnewphno());
             cstmt.setInt(4, amodel.getInchrgid());             
             cstmt.setString(5, amodel.getResponse());
             
  
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
		
	}


	public CustPhoneAdrsNumberHistoryModel getPertCustPhnConnStatAfterApply(int custid){
		
		CoreHash aCoreHash=new CoreHash();
		aCoreHash.clear();
		System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
		
		int sno=1;	
		ResultSet rs=null;
		//PhoneModel um=null;
		CustPhoneAdrsNumberHistoryModel um=null;
		Statement st=null;
	        try
	        {
	        	con=getConnection();     	
	        	st=con.createStatement();
	       	//String sql="SELECT  CAPP.PHNO, CAPP.CUSTID, CM.CFSTNAME, CAPP.CONECTYPEID, CTM.CONTYPENAME, CAPP.PURPSETYPEID, PTM.PURPOSETYPENAME, CAPP.FACILTYPEID, FTM.FACILTYPENAME,  CAPP.CATEGORYCODE, CAPP.CONCESIONCODE, CAPP.PAMOUNT, TO_CHAR(CAPP.PAYDATE,'DD-MM-YY'), TO_CHAR(CAPP.APPLIEDDATE,'DD-MM-YY'),TO_CHAR(CAPP.ISSUEDATE,'DD-MM-YY'), CAPP.STATUS,CAPP.INCHRGID,EM.EMPFSTNAME FROM  CUSTAPPLY4PHONEMSTR CAPP, CUSTOMER CM, PURPOSETYPEMSTR  PTM, CONECTIONTYPEMSTR  CTM, FACILTYPEMSTR  FTM, EMPLOYEESMASTER  EM WHERE  (CAPP.CUSTID=CM.CUSTID) AND(CAPP.CONECTYPEID=CTM.CONTYPEID)  AND(CAPP.PURPSETYPEID=PTM.PURPOSETYPEID) AND(CAPP.FACILTYPEID=FTM.FACILTYPEID)AND CAPP.CUSTID="+custid;
			String sql="SELECT  HN.NEWPHNO,HN.CUSTID, CM.CFSTNAME,  TO_CHAR(HN.APLIEDDATE,'DD-MM-YY'), TO_CHAR(HN.ISSUEDATE,'DD-MM-YY'), HN.STATUS, HN.TXID, HN.INCHRGID, EM.EMPFSTNAME FROM  HSTRY4CHNGNUMBER HN, CUSTOMER CM, EMPLOYEESMASTER  EM  WHERE (HN.CUSTID=CM.CUSTID) AND(EM.EMPID=HN.INCHRGID)  AND (HN.CUSTID="+custid+" AND  HN.TXID=(SELECT MAX(TXID) FROM  HSTRY4CHNGNUMBER  WHERE  CUSTID="+custid+" AND STATUS LIKE 'ACTIVE'))";	
				rs=st.executeQuery(sql);
				while(rs.next()){				
				um=new CustPhoneAdrsNumberHistoryModel();			
				String cid=rs.getString(1);			
				um.setCustnewphno(cid);			
				um.setCustid(rs.getInt(2));			
				um.setCustname(rs.getString(3));				
				um.setAplydate(rs.getString(4));
				um.setIsuedate(rs.getString(5));			
				um.setStatus(rs.getString(6));
				um.setTxid(rs.getInt(7));
				um.setInchrgid(rs.getInt(8));			
				um.setInchrgname(rs.getString(9));			
				
				aCoreHash.put(new Integer(sno),um);
				    sno++;
			  
	             }
		}
		catch(Exception e)
		{e.printStackTrace();
			LoggerManager.writeLogWarning(e);
		}
		finally
		{
		 try{
			 if(con!=null)
				 con.close();
			 
		 }
		 catch(Exception e){}
		}
		return um;
	}

	
	
	
	
	
public CustPhoneAdrsNumberHistoryModel getCustNewPhnoWithOldNumber(String oldnumber){
		
		CoreHash aCoreHash=new CoreHash();
		aCoreHash.clear();
		System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
		
		int sno=1;	
		ResultSet rs=null;
		//PhoneModel um=null;
		CustPhoneAdrsNumberHistoryModel um=null;
		Statement st=null;
	        try
	        {
	        	con=getConnection();     	
	        	st=con.createStatement();
	       
			String sql="SELECT HN.NEWPHNO,HN.CUSTID,CM.CFSTNAME,HN.OLDPHNO  FROM HSTRY4CHNGNUMBER HN,CUSTOMER CM WHERE (HN.CUSTID=CM.CUSTID) AND HN.OLDPHNO='"+oldnumber+"' AND HN.TXID IN (SELECT MAX(TXID) FROM  HSTRY4CHNGNUMBER  WHERE CUSTID IN(SELECT CUSTID FROM  HSTRY4CHNGADDRS  WHERE OLDPHNO="+oldnumber+")) AND HN.STATUS LIKE 'ACTIVE'";	
				rs=st.executeQuery(sql);
				while(rs.next()){				
				um=new CustPhoneAdrsNumberHistoryModel();			
				String cid=rs.getString(1);			
				um.setCustnewphno(cid);			
				um.setCustid(rs.getInt(2));			
				um.setCustname(rs.getString(3));				
				um.setCustoldphno(rs.getString(4));	
				
				aCoreHash.put(new Integer(sno),um);
				    sno++;
			  
	             }
		}
		catch(Exception e)
		{e.printStackTrace();
			LoggerManager.writeLogWarning(e);
		}
		finally
		{
		 try{
			 if(con!=null)
				 con.close();
			 
		 }
		 catch(Exception e){}
		}
		return um;
	}
	
	
	
	
	
	
	
public CustPhoneAdrsNumberHistoryModel getCustFacilityDetails(int custid){
		
		CoreHash aCoreHash=new CoreHash();
		aCoreHash.clear();
		System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
		
		int sno=1;	
		ResultSet rs=null;
		//PhoneModel um=null;
		CustPhoneAdrsNumberHistoryModel  um=null;
		Statement st=null;
	        try
	        {
	        	con=getConnection();     	
	        	st=con.createStatement();
	       	String sql="SELECT CFH.PHNO,  CFH.CUSTID,  CM.CFSTNAME,  CFH.NEWFACLTYPEID,  FM.FACILTYPENAME, TO_CHAR(CFH.APLIEDATE,'DD-MM-YY'),TO_CHAR(CFH.ISSUEDATE,'DD-MM-YY'), CFH. INCHRGID, EM.EMPFSTNAME,   CFH.TXID,  CFH.STATUS  FROM  CUST_FACILITY_HISTORY CFH,  CUSTOMER CM, EMPLOYEESMASTER EM, FACILTYPEMSTR  FM   WHERE (EM.EMPID=CFH.INCHRGID) AND(CFH.CUSTID=CM.CUSTID) AND( CFH.NEWFACLTYPEID=FM.FACILTYPEID) AND( CFH.CUSTID="+custid+"  AND  CFH.TXID=(SELECT MAX(TXID) FROM  CUST_FACILITY_HISTORY WHERE  CUSTID="+custid+" AND STATUS LIKE 'ACTIVE')) ";
				
				rs=st.executeQuery(sql);
				while(rs.next()){				
				um=new CustPhoneAdrsNumberHistoryModel();			
				String cid=rs.getString(1);			
				um.setCustnewphno(cid);			
				um.setCustid(rs.getInt(2));			
				um.setCustname(rs.getString(3));
				um.setFaciltypeid(rs.getInt(4));
				um.setNewfacility(rs.getString(5));
				um.setAplydate(rs.getString(6));
				um.setIsuedate(rs.getString(7));				
				um.setInchrgid(rs.getInt(8));
				um.setInchrgname(rs.getString(9));
				um.setTxid(rs.getInt(10));
				um.setStatus(rs.getString(11));	
				
				 aCoreHash.put(new Integer(sno),um);
				    sno++;
			  
	             }
		}
		catch(Exception e)
		{e.printStackTrace();
			LoggerManager.writeLogWarning(e);
		}
		finally
		{
		 try{
			 if(con!=null)
				 con.close();
			 
		 }
		 catch(Exception e){}
		}
		return um;
	}




public CustPhoneAdrsNumberHistoryModel getCustPurposeDetails(int custid){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	String sql="SELECT   CPH. PHNO,CPH.CUSTID, CM.CFSTNAME,  CPH.NEWPRPSTYPID, PTM.PURPOSETYPENAME, TO_CHAR(CPH.APLIEDATE,'DD-MM-YY'),TO_CHAR(CPH.ISSUEDATE,'DD-MM-YY'),CPH. INCHRGID,EM.EMPFSTNAME, CPH.STATUS, CPH.TXID FROM  CUST_PERPOSE_HISTORY CPH, PURPOSETYPEMSTR PTM, EMPLOYEESMASTER EM, CUSTOMER CM WHERE(CPH. INCHRGID=EM.EMPID) AND(PTM.PURPOSETYPEID=CPH.NEWPRPSTYPID) AND(CPH.CUSTID=CM.CUSTID) AND(CPH.CUSTID ="+custid+" AND   CPH.TXID=(SELECT MAX(TXID) FROM  CUST_PERPOSE_HISTORY WHERE CUSTID="+custid+" AND STATUS LIKE 'ACTIVE')) ";
			
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setPerposetypeid(rs.getInt(4));
			um.setNewperposetypename(rs.getString(5));
			um.setAplydate(rs.getString(6));
			um.setIsuedate(rs.getString(7));				
			um.setInchrgid(rs.getInt(8));
			um.setInchrgname(rs.getString(9));
			um.setStatus(rs.getString(10));	
			um.setTxid(rs.getInt(11));
			
			
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}


public CustPhoneAdrsNumberHistoryModel getCustConectDetails(int custid){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	String sql="SELECT   CCH.PHNO,CCH.CUSTID, CM.CFSTNAME, CCH.NEWCONTYPEID, CTM.CONTYPENAME,TO_CHAR(CCH.APLIEDATE,'DD-MM-YY'),TO_CHAR(CCH.ISSUEDATE,'DD-MM-YY'), CCH.INCHRGID, EM.EMPFSTNAME, CCH.TXID,CCH.STATUS FROM  CUST_CONNECT_HISTORY  CCH, CONECTIONTYPEMSTR  CTM, CUSTOMER  CM, EMPLOYEESMASTER  EM WHERE (CCH.INCHRGID=EM.EMPID) AND(CCH.CUSTID=CM.CUSTID) AND(CTM.CONTYPEID=CCH.NEWCONTYPEID) AND(CCH.CUSTID="+custid+" AND  CCH.TXID=(SELECT MAX(TXID) FROM  CUST_CONNECT_HISTORY WHERE  CUSTID="+custid+"  AND STATUS LIKE 'ACTIVE'))";
			
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setConectypeid(rs.getInt(4));
			um.setNewconectypename(rs.getString(5));
			um.setAplydate(rs.getString(6));
			um.setIsuedate(rs.getString(7));				
			um.setInchrgid(rs.getInt(8));
			um.setInchrgname(rs.getString(9));
			um.setTxid(rs.getInt(10));
			um.setStatus(rs.getString(11));	
			
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}


public CoreHash getAllCustAdresCmplRequests(){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	String sql="SELECT HA.PHNO,HA.CUSTID,CM.CFSTNAME,HA.NEWADDRES,TO_CHAR(HA.APPLYDATE,'DD-MM-YY'),HA.STATUS,HA.TXID  FROM  HSTRY4CHNGADDRS  HA, CUSTOMER CM  WHERE(HA.CUSTID=CM.CUSTID)  AND STATUS LIKE 'DEACTIVE'";
			
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setNewaddress(rs.getString(4));				
			um.setAplydate(rs.getString(5));			
			um.setStatus(rs.getString(6));			
			um.setTxid(rs.getInt(7));
							
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}



public CoreHash getAllCustFacilCmplRequests(){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
      
		String sql="SELECT CFH.PHNO,CFH.CUSTID,CM.CFSTNAME ,CFH.NEWFACLTYPEID,FTM.FACILTYPENAME, TO_CHAR(CFH.APLIEDATE,'DD-MM-YY'),CFH.STATUS,CFH.TXID FROM CUST_FACILITY_HISTORY  CFH,CUSTOMER  CM ,FACILTYPEMSTR  FTM WHERE (CFH.NEWFACLTYPEID=FTM.FACILTYPEID)AND(CFH.CUSTID=CM.CUSTID)AND STATUS LIKE 'DEACTIVE'";	
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setFaciltypeid(rs.getInt(4));			
			um.setNewfacility(rs.getString(5));					
			um.setAplydate(rs.getString(6));			
			um.setStatus(rs.getString(7));			
			um.setTxid(rs.getInt(8));
							
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}
	
public CoreHash getAllCustPurposeTypeCmplRequests(){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
      
		String sql="SELECT  CPH.PHNO, CPH.CUSTID, CM.CFSTNAME, CPH.NEWPRPSTYPID, PTM.PURPOSETYPENAME, TO_CHAR(CPH.APLIEDATE,'DD-MM-YY'), CPH.STATUS, CPH.TXID FROM CUST_PERPOSE_HISTORY  CPH,PURPOSETYPEMSTR  PTM,CUSTOMER CM WHERE(CPH.CUSTID=CM.CUSTID)AND(CPH.NEWPRPSTYPID=PTM.PURPOSETYPEID)AND CPH.STATUS  LIKE 'DEACTIVE'";	
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setPerposetypeid(rs.getInt(4));			
			um.setNewperposetypename(rs.getString(5));					
			um.setAplydate(rs.getString(6));			
			um.setStatus(rs.getString(7));			
			um.setTxid(rs.getInt(8));
							
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}


public CoreHash getAllCustConnectTypeCmplRequests(){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
      
		String sql="SELECT CCH.PHNO, CCH.CUSTID, CM.CFSTNAME, CCH.NEWCONTYPEID,  CTM.CONTYPENAME,TO_CHAR(CCH.APLIEDATE,'DD-MM-YY'),  CCH.STATUS, CCH.TXID  FROM CUST_CONNECT_HISTORY  CCH,CONECTIONTYPEMSTR  CTM ,CUSTOMER CM  WHERE(CCH.CUSTID=CM.CUSTID) AND(CCH.NEWCONTYPEID=CTM.CONTYPEID) AND  CCH.STATUS LIKE 'DEACTIVE'";	
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setConectypeid(rs.getInt(4));			
			um.setNewconectypename(rs.getString(5));					
			um.setAplydate(rs.getString(6));			
			um.setStatus(rs.getString(7));			
			um.setTxid(rs.getInt(8));
							
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}

public CoreHash getAllCustomersGeneralCmplaints(){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
      
		String sql=" SELECT QS.PHNO,QS.CUSTID,CM.CFSTNAME,QS.QUERYID, QS.QUERYTYPE, QS.QUEDESC,QS.STATUS FROM QUERIESANDSOLV  QS,CUSTOMER CM WHERE (QS.CUSTID=CM.CUSTID) AND QS.STATUS LIKE 'NOTSOLV'";	
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setQueryid(rs.getInt(4));			
			um.setQuerytype(rs.getString(5));					
			um.setQuerydesc(rs.getString(6));			
			um.setStatus(rs.getString(7));
							
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}


public CustPhoneAdrsNumberHistoryModel getPertiCustomersGeneralCmplaintsQueryDetails(int qid){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
      
		String sql=" SELECT QS.PHNO,QS.CUSTID,CM.CFSTNAME,QS.QUERYID, QS.QUERYTYPE, QS.QUEDESC,QS.STATUS FROM QUERIESANDSOLV  QS,CUSTOMER CM WHERE (QS.CUSTID=CM.CUSTID) AND QS.STATUS LIKE 'NOTSOLV' AND QS.QUERYID="+qid;	
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setQueryid(rs.getInt(4));			
			um.setQuerytype(rs.getString(5));					
			um.setQuerydesc(rs.getString(6));			
			um.setStatus(rs.getString(7));
							
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}






public CoreHash getAllPertCustCmplntSolvDetails(int custid){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;	
	CustPhoneAdrsNumberHistoryModel  um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
      
		String sql="SELECT QS.PHNO,QS.CUSTID,CM.CFSTNAME,QS.QUERYID,QS.QUERYTYPE,QS.QUEDESC,QS.RESPONSE,QS.STATUS ,QS.REPLYEMPID,EM.EMPFSTNAME FROM QUERIESANDSOLV  QS,CUSTOMER CM, EMPLOYEESMASTER EM WHERE (QS.CUSTID=CM.CUSTID) AND (EM.EMPID=QS.REPLYEMPID)AND QS.CUSTID="+custid+" AND QS.STATUS LIKE 'SOLV'";	
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));
			um.setQueryid(rs.getInt(4));			
			um.setQuerytype(rs.getString(5));					
			um.setQuerydesc(rs.getString(6));
			um.setResponse(rs.getString(7));
			um.setStatus(rs.getString(8));
			um.setInchrgid(rs.getInt(9));			
			um.setInchrgname(rs.getString(10));	
			
			
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}






public CustPhoneAdrsNumberHistoryModel getPertCustPhnoByCustid(int custid){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	//PhoneModel um=null;
	CustPhoneAdrsNumberHistoryModel um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	
		String sql="SELECT  NEWPHNO  FROM  HSTRY4CHNGNUMBER  WHERE  CUSTID="+custid;	
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new CustPhoneAdrsNumberHistoryModel();			
			String cid=rs.getString(1);			
			um.setCustnewphno(cid);			
					
			
			aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}



}
