package com.dts.project.dao;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.sql.Blob;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.dts.core.dao.AbstractDataAccessObject;
import com.dts.core.util.CoreHash;
import com.dts.core.util.DateWrapper;
import com.dts.core.util.LoggerManager;
import com.dts.project.model.ConnectFacilityPurposeModel;
import com.dts.project.model.CustPhoneAdrsNumberHistoryModel;
import com.dts.project.model.CustomerModel;




public class CustomerDAO extends AbstractDataAccessObject {
	public boolean flag=false;
	public Connection con=null;
	
	public CustomerDAO() {
		// TODO Auto-generated constructor stub
	}

	
	
public boolean addCustomerProfile(CustomerModel addcust){
		
		String photo=addcust.getCustphoto();
		String adrsprf=addcust.getAddressprof();
		
		CallableStatement cstmt=null;
		  try 
		    {
			  System.out.println("photo="+photo);
	        	java.io.File f=new File(photo);
	        	FileInputStream fis=new FileInputStream(f); 
		    	
	        	
	        	
	        	
	        	java.io.File f1=new File(adrsprf);
	        	FileInputStream fis1=new FileInputStream(f1); 
		    	
	        	
	        	con=getConnection();		       
		        cstmt=con.prepareCall("{ call ADD_CUSTOMER(?,?,?,?,?,?,?,?,?,?,?,?,?,?)}");
         cstmt.setString(1, addcust.getCustfname());
         cstmt.setString(2, addcust.getCustmname());
         cstmt.setString(3, addcust.getCustlname());
         cstmt.setString(4, DateWrapper.parseDate(addcust.getDob()));
         cstmt.setString(5, DateWrapper.parseDate(addcust.getDoj()));         
         cstmt.setString(6, addcust.getAddress());
         cstmt.setBinaryStream(7,fis1,(int)f1.length());        
         cstmt.setString(8, addcust.getEmailid()); 
         cstmt.setString(9, addcust.getPhno());
         cstmt.setBinaryStream(10,fis,(int)f.length());
         cstmt.setString(11, addcust.getGender());
         cstmt.setString(12, addcust.getMstatus());         
         cstmt.setInt(13, addcust.getQuestionid());
         cstmt.setString(14, addcust.getAnswer());
         
        
		       int i= cstmt.executeUpdate();
		         if(i==1)
		         {
		          flag=true;
		          con.commit();
		         }
		         else
		         {
		        	 flag=false;
		        	 con.rollback();
		         }

		    } 
		    
		    catch (Exception e) 
		    {
		        e.printStackTrace();
		        flag=false;
		        try 
		        {
		            con.rollback();
		        } 
		        catch (SQLException se) 
		        {
		            se.printStackTrace();
		        }
		    }
		    
		    finally
			{
			 try{
				 if(con!=null)
					 con.close();				 
			 }
			 catch(Exception e){}
			}
		    return flag;
		
	}
	




public boolean UpdateCustomerProfile(CustomerModel updatecust){
	
	String photo=updatecust.getCustphoto();
	String adrsprof=updatecust.getAddressprof();
	CallableStatement cstmt=null;
	  try 
	    {
		 
        	java.io.File f=new File(photo);
        	FileInputStream fis=new FileInputStream(f); 
	    	
        	java.io.File f1=new File(adrsprof);
        	FileInputStream fis1=new FileInputStream(f1); 
        	
        	
        	con=getConnection();		       
	        cstmt=con.prepareCall("{ call UPDATE_CUSTOMER(?,?,?,?,?,?,?)}");
     
	 cstmt.setInt(1, updatecust.getCustid());             
     cstmt.setString(2, updatecust.getAddress());
     cstmt.setBinaryStream(3,fis1,(int)f1.length());
     cstmt.setString(4, updatecust.getEmailid());
     cstmt.setString(5, updatecust.getPhno());
     cstmt.setBinaryStream(6,fis,(int)f.length());
     cstmt.setString(7, updatecust.getMstatus()); 
     
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
}







public CoreHash getCustDetailsFromCust4History(){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());
	
	
	int sno=1;
	
	ResultSet rs=null;
	CustPhoneAdrsNumberHistoryModel um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	String sql="SELECT CH.CUSTID, CM.CFSTNAME,CH.NEWPHNO FROM HSTRY4CHNGNUMBER CH,CUSTOMER CM WHERE (CH.CUSTID=CM.CUSTID)";
			
			rs=st.executeQuery(sql);
			while(rs.next()){
				
			um=new CustPhoneAdrsNumberHistoryModel();		
			
			int cid=rs.getInt(1);			
			um.setCustid(cid);
			um.setCustname(rs.getString(2));
			um.setCustnewphno(rs.getString(3));	
			
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}
	


public CustPhoneAdrsNumberHistoryModel getCustDetailsFromCust4HistoryByID(int custid){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());
	
	
	int sno=1;
	
	ResultSet rs=null;
	CustPhoneAdrsNumberHistoryModel um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	String sql="SELECT CH.CUSTID, CM.CFSTNAME,CH.NEWPHNO FROM HSTRY4CHNGNUMBER CH,CUSTOMER CM WHERE (CH.CUSTID=CM.CUSTID) AND CH.CUSTID="+custid;
			
			rs=st.executeQuery(sql);
			while(rs.next()){
				
			um=new CustPhoneAdrsNumberHistoryModel();		
			
			int cid=rs.getInt(1);			
			um.setCustid(cid);
			System.out.println("---in DAO cid-------"+cid);
			
			um.setCustname(rs.getString(2));
			
			System.out.println("---rs.getString(2)------"+rs.getString(2));
			um.setCustnewphno(rs.getString(3));	
			System.out.println("---rs.getString(3)------"+rs.getString(3));
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}
	



public CustomerModel getPerticularCustProfile(String image,int cstid){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());
	
	
	int sno=1;
	
	ResultSet rs=null;
	CustomerModel um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	String sql="SELECT CUSTID,CFSTNAME,TO_CHAR(CDOB,'DD-MM-YYYY'),TO_CHAR(CDOJ,'DD-MM-YYYY'),CHNO,CSTREET,CCITY,CSTATE,CCOUNTRY,CPHNO,CEMAILID,CPIN,LOGINTYPE,PHOTO from CUSTOMER where CUSTID="+cstid;
			
			rs=st.executeQuery(sql);
			while(rs.next()){
				
			um=new CustomerModel();		
			
			int cid=rs.getInt(1);
			
			um.setCustid(cid);
			um.setCustfname(rs.getString(2));
			//um.setCustmname(rs.getString(3));
			//um.setCustlname(rs.getString(4));
			um.setDob(rs.getString(3));
			um.setDoj(rs.getString(4));
			um.setCusthno(rs.getString(5));
			um.setStreet(rs.getString(6));
			um.setCity(rs.getString(7));
			um.setState(rs.getString(8));
			um.setCountry(rs.getString(9));
			um.setPhno(rs.getString(10));
			um.setEmailid(rs.getString(11));			
			//um.setCustuname(rs.getString(14));
			//um.setCustpass(rs.getString(15));
			um.setCustpin(rs.getString(12));
			um.setLogintype(rs.getString(13));
			
			
			
			Blob bb =rs.getBlob(14);
			byte bb1[]=bb.getBytes(1,(int)bb.length());
			OutputStream fout1=new FileOutputStream(image+"/"+cid+".gif");
			fout1.write(bb1);			
			um.setCustphoto(cid+".gif");
			
			
			
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}
	


public CustomerModel getCustProfile(String image,String addressprofs,String username){
	
	int sno=1;
	
	ResultSet rs=null;
	CustomerModel um=null;
	Statement st=null;
        try
        {
        	con=getConnection();  
        	
        	System.out.println("----getConnection-------"+con);
        	st=con.createStatement();
       	//String sql="SELECT CUSTID,CFSTNAME,CMIDNAME,CLSTNAME,TO_CHAR(CDOB,'DD-MM-YYYY'),TO_CHAR(CDOJ,'DD-MM-YYYY'),CHNO,CSTREET,CCITY,CSTATE,CCOUNTRY,CPHNO,CEMAILID,CUSERNAME,CPASSWORD,CPIN,CPHOTO FROM CUSTOMER WHERE CUSERNAME='"+username+"'";
		String sql="SELECT  CUSTID, CFSTNAME, CMIDNAME, CLSTNAME, TO_CHAR(CDOB,'DD-MM-YYYY'), TO_CHAR(CDOR,'DD-MM-YYYY'), CADDRESS, CADRESPROOF, CEMAILID, CPHNO, CPHOTO, CUSERNAME, CPASSWORD, CGENDER, MSTATUS, CQUESID, ANSWER FROM  CUSTOMER WHERE  CUSERNAME='"+username+"'";	
			rs=st.executeQuery(sql);
			while(rs.next()){
				
			um=new CustomerModel();		
			
			int cid=rs.getInt(1);
			System.out.println("----cid----------------->"+cid);
			um.setCustid(cid);
			
			
			um.setCustfname(rs.getString(2));
			um.setCustmname(rs.getString(3));
			um.setCustlname(rs.getString(4));
			um.setDob(rs.getString(5));
			um.setDoj(rs.getString(6));
			um.setAddress(rs.getString(7));
			
			Blob bb =rs.getBlob(8);
			byte bb1[]=bb.getBytes(1,(int)bb.length());
			OutputStream fout1=new FileOutputStream(addressprofs+"/"+cid+".gif");
			fout1.write(bb1);			
			um.setAddressprof(cid+".gif");
			
			
			um.setEmailid(rs.getString(9));			
			um.setPhno(rs.getString(10));
			int cid1=rs.getInt(1);
			Blob bbb =rs.getBlob(11);
			byte bbb1[]=bb.getBytes(1,(int)bbb.length());
			OutputStream fout2=new FileOutputStream(image+"/"+cid1+".gif");
			fout2.write(bbb1);	
			
			um.setCustphoto(cid1+".gif");
						
			um.setCustuname(rs.getString(12));
			um.setCustpass(rs.getString(13));
			um.setGender(rs.getString(14));
			um.setMstatus(rs.getString(15));
			um.setQuestionid(rs.getInt(16));
			um.setAnswer(rs.getString(17));
			
			
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}


public CustomerModel getPerCustIDBYName(String username){
	
	int sno=1;
	
	ResultSet rs=null;
	CustomerModel um=null;
	Statement st=null;
        try
        {
        	con=getConnection();  
        	
        	System.out.println("----getConnection-------"+con);
        	st=con.createStatement();
       	
		String sql="SELECT  CUSTID, CFSTNAME FROM  CUSTOMER WHERE  CUSERNAME='"+username+"'";	
			rs=st.executeQuery(sql);
			while(rs.next()){
				
			um=new CustomerModel();		
			
			int cid=rs.getInt(1);
			System.out.println("----cid----------------->"+cid);
			um.setCustid(cid);			
			um.setCustfname(rs.getString(2));
			
			
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return um;
}




}
