package com.dts.project.dao;

import java.io.File;
import java.io.FileInputStream;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.dts.core.dao.AbstractDataAccessObject;
import com.dts.core.util.CoreHash;
import com.dts.core.util.DateWrapper;
import com.dts.core.util.LoggerManager;
import com.dts.project.model.ConnectFacilityPurposeModel;
import com.dts.project.model.CustomerModel;
import com.dts.project.model.PhoneModel;

public class PhoneDAO extends AbstractDataAccessObject {
	public boolean flag=false;
	public Connection con=null;
	public PhoneDAO() {
		// TODO Auto-generated constructor stub
	}
public boolean addCustAplcForNewConnection(PhoneModel addphone){
		
		
		
		CallableStatement cstmt=null;
		  try 
		    {
			  
	        	
	        	con=getConnection();		       
		        cstmt=con.prepareCall("{ call APLCTION_NEWCONNECTION_FORM(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)}");
         
		        
		 cstmt.setInt(1, addphone.getCustid());
         cstmt.setInt(2, addphone.getConecttypeid());
         cstmt.setInt(3, addphone.getPurposetypid());
         cstmt.setInt(4, addphone.getFaciltypid());
         cstmt.setString(5, addphone.getPanno());
         cstmt.setString(6, addphone.getIstrumentreq());
         cstmt.setString(7, addphone.getWiringreq());        
         cstmt.setString(8, addphone.getCategorycode());
         cstmt.setString(9, addphone.getCositioncode());               
         cstmt.setString(10, addphone.getPaymntmode());         
         cstmt.setString(11, addphone.getPaydtls());    
         cstmt.setString(12, DateWrapper.parseDate(addphone.getPaydate()));
         cstmt.setDouble(13, addphone.getPamount());
         cstmt.setString(14, addphone.getBankname());         
         cstmt.setString(15, addphone.getBranch());
         cstmt.setString(16, DateWrapper.parseDate(addphone.getAplydate()));
         //cstmt.setInt(16, addphone.getInchrgid());
        
		       int i= cstmt.executeUpdate();
		         if(i==1)
		         {
		          flag=true;
		          con.commit();
		         }
		         else
		         {
		        	 flag=false;
		        	 con.rollback();
		         }

		    } 
		    
		    catch (Exception e) 
		    {
		        e.printStackTrace();
		        flag=false;
		        try 
		        {
		            con.rollback();
		        } 
		        catch (SQLException se) 
		        {
		            se.printStackTrace();
		        }
		    }
		    
		    finally
			{
			 try{
				 if(con!=null)
					 con.close();				 
			 }
			 catch(Exception e){}
			}
		    return flag;
		
	}
	

public boolean UpdateCustAplcForNewConnection(int custid,int inchrgid){
	
	
	
	CallableStatement cstmt=null;
	  try 
	    {
		  
        	
        	con=getConnection();		       
	        cstmt=con.prepareCall("{ call ISSUE_NEW_CONNECTION_BY_EMP(?,?)}");
     
	        
	 cstmt.setInt(1, custid);  
	 System.out.println("------------in DAO------------"+custid);
     cstmt.setInt(2, inchrgid);
     System.out.println("------------in DAO------------"+inchrgid);
    
	       int i= cstmt.executeUpdate();
	       System.out.println("------------i------------"+i);
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
}

public boolean DeleteCustAplcForNewConnection(int custid,int inchrgid){
	
	
	
	CallableStatement cstmt=null;
	  try 
	    {
		  
        	
        	con=getConnection();		       
	        cstmt=con.prepareCall("{ call DELETE_APLCTION_NEWCONNECTION_FORM(?,?)}");
             
	 cstmt.setInt(1, custid);     
     cstmt.setInt(2, inchrgid);
    
	       int i= cstmt.executeUpdate();
	         if(i==1)
	         {
	          flag=true;
	          con.commit();
	         }
	         else
	         {
	        	 flag=false;
	        	 con.rollback();
	         }

	    } 
	    
	    catch (Exception e) 
	    {
	        e.printStackTrace();
	        flag=false;
	        try 
	        {
	            con.rollback();
	        } 
	        catch (SQLException se) 
	        {
	            se.printStackTrace();
	        }
	    }
	    
	    finally
		{
		 try{
			 if(con!=null)
				 con.close();				 
		 }
		 catch(Exception e){}
		}
	    return flag;
	
}

public CoreHash getAllCustPhoneConectReqstsFromCust(){
	
	CoreHash aCoreHash=new CoreHash();
	aCoreHash.clear();
	System.out.println("aCoreHash--"+aCoreHash.isEmpty());	
	
	int sno=1;	
	ResultSet rs=null;
	PhoneModel um=null;
	Statement st=null;
        try
        {
        	con=getConnection();     	
        	st=con.createStatement();
       	String sql="SELECT  CAPP.PHNO,CAPP.CUSTID,CM.CFSTNAME,CAPP.CONECTYPEID, CTM.CONTYPENAME, CAPP.PURPSETYPEID, PTM.PURPOSETYPENAME, CAPP.FACILTYPEID, FTM.FACILTYPENAME, CAPP.PANNO,CAPP.INSTRUMNTREQ, CAPP.WIRINGREQ, CAPP.CATEGORYCODE, CAPP.CONCESIONCODE, CAPP.PAYMNTMODE, CAPP.PAYDTLS, TO_CHAR(CAPP.PAYDATE,'DD-MM-YYYY'), CAPP.BANKNAME, CAPP.BRANCH, TO_CHAR(CAPP.APPLIEDDATE,'DD-MM-YYYY'), CAPP.TXID, CAPP.PAMOUNT,CAPP.STATUS  FROM  CUSTAPPLY4PHONEMSTR CAPP, CUSTOMER CM, PURPOSETYPEMSTR  PTM, CONECTIONTYPEMSTR  CTM, FACILTYPEMSTR  FTM WHERE  (CAPP.CUSTID=CM.CUSTID) AND(CAPP.CONECTYPEID=CTM.CONTYPEID) AND(CAPP.PURPSETYPEID=PTM.PURPOSETYPEID) AND(CAPP.FACILTYPEID=FTM.FACILTYPEID) AND CAPP.STATUS LIKE 'DEACTIVE' ";
			
			rs=st.executeQuery(sql);
			while(rs.next()){				
			um=new PhoneModel();			
			String cid=rs.getString(1);			
			um.setPhno(cid);			
			um.setCustid(rs.getInt(2));			
			um.setCustname(rs.getString(3));			
			um.setConecttypeid(rs.getInt(4));
			um.setConecttypename(rs.getString(5));							
			um.setPurposetypid(rs.getInt(6));
			um.setPurposetypname(rs.getString(7));	
			um.setFaciltypid(rs.getInt(8));
			um.setFaciltypename(rs.getString(9));
			um.setPanno(rs.getString(10));
			um.setIstrumentreq(rs.getString(11));
			um.setWiringreq(rs.getString(12));			
			um.setCategorycode(rs.getString(13));
			um.setCositioncode(rs.getString(14));
			um.setPaymntmode(rs.getString(15));
			um.setPaydtls(rs.getString(16));
			um.setPaydate(rs.getString(17));
			um.setBankname(rs.getString(18));
			um.setBranch(rs.getString(19));
			um.setAplydate(rs.getString(20));
			um.setTxid(rs.getInt(21));
			um.setPamount(rs.getDouble(22));
			um.setStatus(rs.getString(23));
			
			
			
			 aCoreHash.put(new Integer(sno),um);
			    sno++;
		  
             }
	}
	catch(Exception e)
	{e.printStackTrace();
		LoggerManager.writeLogWarning(e);
	}
	finally
	{
	 try{
		 if(con!=null)
			 con.close();
		 
	 }
	 catch(Exception e){}
	}
	return aCoreHash;
}



	
}
